;;                                                                                                              ;
;;                              Vsom V6  Somme des dbits sur un calque de polyligne                            ;
;;                                                                                                              ;
;; Habille et calcule un shma aro (exemple et blocs dans joch04.free.fr/tmp/vsom6.zip)                        ;
;; les polys du rseau commencent toutes par une bouche et finnissent par une jonction. Les blocs sont placs   ;
;; sur des moints de la polyligne. Si on ne neux pas la poly paisse relancer la commande et chap              ;
;; version en cours (vrif des variable et test de bug qui plantent le calcul a complter)                      ;
;;                                                                                                              ;
;;                                                                                                              ;
;; VSOM    pour lancer le calcul des diamtre, une poly dont la largeur est quivalente au                      ;
;;         diamtre de la gaine est trace dans le calque --CVC-tmp ce calque est effac  chaque calcul        :
;; pour donner un aspect moins raide, on peut faire des raccord dans les angles                                 ;
;;                                                                                                              ;
;; RTT     commande qui permet de faire un raccord sur une poly en fonction de son paisseur                    ;
;; (coude R = 1 D) pour un autre rayon modifiez en dur dans le code la valuer de K )                            ;
;;                                                                                                              ;
;;  DTB    commande qui permet poser des bouches automatiquement ser les points des position des diffuseurs     ;
;;   renseigne automatiquement l'attribut Q en ft du DEBIT du diffuseur                                         ;
;;                                                                                                              ;
;;                                                                                                              ;



(defun c:vsom
	      (/       ent     i       j       k       n       lay     der     sspoly  poly
	       lsvtx   lstvtx  vtx     pt      ssblocs lsbloc  bloc    nombloc nombloc2
	       hbloc   lsbranche       branche Qcourant	       ta      Qt      qc      v
	       doc     test    testb  testbb ldia
	      )




					; initialisation VL
  (vl-load-com)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)		; Activer le dbut de l'undo
  (setq	v 3.0
	;; 3m/s pour un auditorium 5 pour des burreaux voir 6 pour les gros diamtres   
	n
	 0
	test 0
	*ldia* nil
  )

  (if (not (tblsearch "LAYER" "--CVC-tmp"))
    (entmakex (list '(0 . "LAYER")
		    '(100 . "AcDbSymbolTableRecord")
		    '(100 . "AcDbLayerTableRecord")
		    (cons 2 "--CVC-tmp")
		    '(70 . 0)
		    '(62 . 32)
	      )
    )
  )

  (command "effacer" (ssget "x" '((8 . "--CVC-tmp"))) "")

  (setq	ent (car
	      (entsel
		"\nChoix d'un lment du calque du rseau  traiter\n"
	      )
	    )
	lay (cdr (assoc 8 (entget ent)))
  )

					; liste de slection des poly et blocs du calque


  (setq	sspoly (ssget "X" (list (cons 0 "LWPOLYLINE") (cons 8 lay)))
	ssbloc (ssget "X" (list (cons 0 "INSERT") (cons 8 lay)))
  )

  ;; cration de la liste des bloc lsbloc (pt hadle nombloc)                                            
  (setq j 0)
  (repeat (sslength ssbloc)
    (setq bloc (ssname ssbloc j)
    )
    (setq
      j	      (+ 1 j)
      hbloc   (cdr (assoc 5 (entget bloc)))
      PT      (cdr (assoc 10 (entget bloc)))
      pt      (reverse (cdr (reverse pt)))
      Vba-ent (vlax-ename->vla-object bloc)
      nombloc (vla-get-effectivename Vba-ent)

    )
    (if	(or (= nombloc "bouche") (= nombloc "jonction"))
      (setq lsbloc (cons (cons nombloc (list pt hbloc)) lsbloc)
      )
    )
  )					;fr ssbloc



;;;                                     traitement des poly  cration de la liste des branches            ;
;;;                     lsbranche de la forme   ( ( nom tp handle1 ) (nom pt handle2) ...)                ;
;;;                                                                                                       ;
  (setq i 0)
  (repeat (sslength sspoly)
    (setq poly (ssname sspoly i)
    )

    (setq lsvtx	(mapcar	'cdr
			(vl-remove-if-not
			  '(lambda (x) (= (car x) 10))
			  (entget poly)
			)
		)
    )
    (princ "\n      ")
(setq lstvtx (append lsvtx lstvtx))

;;;   test du sens de poly (jonction en fin    et     cration de la branche
    (setq k 0)
    (while
      (< k (length lsvtx))
       (setq test 0
	     vtx  (nth k lsvtx)
       )
       (foreach	bloc lsbloc
	 (setq pt (cadr bloc))
	 ;; si le bloc est sur la poly on l'ajoute  la brenche
	 (if (equal vtx pt 0.02)
	   (setq branche (cons bloc branche)
		 test	 1
	   )
	   ;;                                                                                                                    ;
	   ;;  rinitialisation du Qt des blocs jonctions leur calcul servant de marqueur pour ordoner le parcour des branches   ;
	   ;;                                                                                                                    ;
	   (if (= "jonction" (car bloc))
	     (progn
	       (setq hbloc (caddr bloc))
	       (Vb-Mod-att (handent hbloc) "Qt" 0)
	     )
	   )
	 )
       )				;fe bloc

       ;; cration d'un bloc vide pour les points de la poly non affect             
       ;; ce point va nous servir  calculer les longueur de diamtres cumuls       
       (if (= 0 test)
	 (setq branche (cons (list "vide" vtx "hvide") branche))
       )
       (setq k (+ 1 k))
    )					;wh vtx vtx




    (setq branche (reverse branche))



    ;;                                                                                              ;
    ;;              controle du sens des polylignes                                                 ;
    ;;                                                                                              ;

    (setq nombloc  (car (car (reverse branche)))
	  nombloc2 (car (car branche))
	  pt	   (cadr (car (reverse branche)))
    )
    ;;  Si le dernier bloc n'est pas une jonction Dssine un cercle, il faudra la retourner
    (if	(or (/= nombloc2 "bouche") (/= nombloc "jonction"))
      (progn
	(entmake (list (cons 0 "CIRCLE")
		       (cons 8 "---EPURES")
		       (cons 62 1)
		       (cons 10 pt)
		       (cons 40 0.5)
		 )
	)
	(setq n (+ 1 n))
      )
    )					;fi



    (setq lsbranche (cons branche lsbranche))
    (setq i (+ 1 i)
	  branche nil
    )


  )					;fr sspoly    Lsbranche prte

  ;;                                    si  des branches a inverser, on sort.

  (if (/= n 0)
    (progn
      (alert "Attention pb sur une extrmit de poly ou son sens")
      (print n)
      (exit)
    )
  )
;;;  test si bloc sans poly                                                                
  (setq testbb 0)
  (foreach bloc	lsbloc
    (setq testb 0)
    (setq pt (cadr bloc))
    (foreach vtx lstvtx
      (if (equal vtx pt 0.02)
	(setq testb 1
	)
      )
    )
    ;; ffe vtx
    ;; si le bloc est sur aucune poly 
    (if	(= 0 testb)

      (progn
	(setq  testbb 1)
	(entmake (list (cons 0 "CIRCLE")
		       (cons 8 "---EPURES")
		       (cons 62 2)
		       (cons 10 pt)
		       (cons 40 0.5)
		 )
	)
      )
      ;; f prog
    )

  )
  ;;ffe bloc

  (if (/= 0 testbb)
    (progn
      (alert "Attention il y a des blocs sans poly")
      (exit)
    )
  )








;;;;;;;;;                                                                                                               ;;;;;;;;
  ;;                                                                                                    ;;;;;;;;
  ;;            Explore fonction pour calculer les branches dans l'ordre                                ;;
  ;;            toute les sous branches doivent avoir t cumules pour                                                 ;;;;
  ;;            Qu'une branche soit traitable test sur le Qt=0   (Q transverssal remis  0)             ;;
  ;;                                                                                                    ;;;;;;;;
;;;;;;;;;                                                                                                               ;;;;;;;;

  (defun explore (arbre / ldia brl bloc nombloc Nonvalide in)

    (setq brl  (car arbre)
	  in   0
	  bloc nil
	  Qt   1
    )
    (setq Nonvalide 0)


    (setq test (+ 1 test)
    )
    (if	(> test 100)
      (progn
	(print " +100 itrations.  jonction sans branche ?")
	(exit)
      )
    )					;f
    ;;boucle pour test si un bloc "jonction" (sauf le dernier) de la branche   Qt =0       
    (while (and (< in (length brl)) (/= 0 (length brl)))

      (setq
	bloc	(nth in brl)
	hbloc	(caddr bloc)
	nombloc	(car bloc)
      ) ;_ Fin de setq


      ;; test du Qt=0 d'un bloc qui n'est pas le dernier      si oui Nonvalide = 1    
      (if (and (/= (+ 1 in) (length brl))
	       (= nombloc "jonction")
	       (= 0 (read (Vb-Val-att (handent hbloc) "Qt")))
	  )

	(setq Nonvalide 1)
      )

      (setq in (+ 1 in))
    ) ;_ Fin de while


    (setq lg-arbre (length arbre))
    (if	(= Nonvalide 1)
      ;;   Si Nonvalide modifi a 1, on ne peut pas calculer la branche               
      ;;   on met donc ce bloc  la fin de celle ci et on rappelle explore            
      ;;   avec cette nouvelle liste en esprant que le 1er lment soit traitable    


      ;; permutation  (gile) le 1er devient le dernier
      (progn
	(setq arbre
	       (append (cdr arbre)
		       (list (car arbre))
	       ) ;_ Fin de append
	) ;_ Fin de setq

	(explore arbre)
;;;             rcurssivit

      ) ;_ Fin de progn

      ;;                                                                                      ;
      ;; Si Nonvalide = 0 la branche est traitable                                            ;
      ;; on traite, suprime cette branche de la collection et relance sur la nouvelle liste   ;
      ;;  si on ne peut pas affecter l'arbre  cdr arbre, c'est la fin !                      ;
      ;;                                                                                      ;
      (progn
	(setq ldia (append (TraiteBranche brl) ldia))
	(trace-poly ldia)
	;;traite branche et mise a jour de la liste des diamtres
	(if (setq arbre (cdr arbre))
	  (explore arbre)
;;;     rcurssivit
	) ;_ Fin de if                          (and (/= 0 lg-arbre)
;;;;;;;                                 par ici la sortie !!!!
      )
    ) ;_ Fin de if
  ) ;_ Fin de defun


;;;fd explore                                                                                                           
;;;fd explore                                                                                                           
;;;fd explore                                                                                                           

  (print "nombre de branches total")
  (print (length lsbranche))


  (explore lsbranche)



  (setq ldia (consolidation *ldia*))
  (setq ldia (vl-sort ldia '(lambda (e1 e2) (< (car e1) (car e2)))))

  (print "rcap des longueurs par diamtre")
  (print ldia)



  (print "sortie normale de Vsom")
;;; Fin de l'undo
  (vla-endundomark doc)
  (princ)
)
;;fin Vsom




;;                                                                                              ;;;;;;;;;;;;;;;;;;;
;;                                              fonctions                                       ;;;;;;;;;;;;;;;;;;;
;;                                                                                              ;;;;;;;;;;;;;;;;;;;

;;                                                                                              ;;;;;;;;;;;;;;;;;;; 
;;                              Traiement   d'une branche et maj Qt                             ;;;;;;;;;;;;;;;;;;; 
;;              branche de la forme   ( ( nom tp handle1 ) (nom pt handle2) ...)                ;;;;;;;;;;;;;;;;;;; 


(defun TraiteBranche (branche / tt i u bloc Qt qc dc dia Qcourant ta ldia lg pt1 pt2)

  (setq	i    0
	bloc nil
	ldia nil
  )

  (while (< i (length branche))

    (setq bloc	  (nth i branche)
	  nombloc (car bloc)
	  hbloc	  (caddr bloc)
	  pt1	  (cadr bloc)
    )
    ;;test et mise a jour suivant le cas  
    (cond

      ;;1er bloc
      ;;                                                      

      ((= i 0)
       (setq ta	      (read (Vb-Val-att (handent hbloc) "Q"))
	     Qcourant ta
       )
       (Vb-Mod-att (handent hbloc) "T" (rtos Qcourant 2 0))

       (setq dia (calc-dia Qcourant v)
       )
       (Vb-Mod-att (handent hbloc) "DIA" dia)
      )




      ;;toutes jonctions sauf la dernire
      ;;                                                      
      ((and (= nombloc "jonction") (/= (+ 1 i) (length branche)))

       (Vb-Mod-att (handent hbloc) "Qc" (rtos Qcourant 2 0))
       (setq Qcourant
	      (+ Qcourant (read (Vb-Val-att (handent hbloc) "Qt")))
       )
       (Vb-Mod-att (handent hbloc) "T" (rtos Qcourant 2 0))

       (setq dia (calc-dia Qcourant v)
       )
       (Vb-Mod-att (handent hbloc) "DIA-t" dia)
      )




      ;;dernire jonction
      ;;                                                      

      ((and (= nombloc "jonction") (= (+ i 1) (length branche)))
       (setq tt 0)

       (Vb-Mod-att (handent hbloc) "Qt" (rtos Qcourant 2 0))

       ;; cas d'arrive sur une colonne l'attribut Qetage permet de renseigner une valleur  cumuler
       ;; utiliser les champs pour chainer les tages                                               
       (if (setq Qc (read (Vb-Val-att (handent hbloc) "Qetage")))
	 (progn
	   (Vb-Mod-att (handent hbloc) "Qc" (rtos Qc 2 0))
	   (setq Qcourant (+ Qcourant Qc))
	 )
	 (Vb-Mod-att (handent hbloc) "Qc" (rtos 0 2 0))
       )				;i

       (Vb-Mod-att (handent hbloc) "T" (rtos Qcourant 2 0))

       (setq dia (calc-dia Qcourant v))
       (Vb-Mod-att (handent hbloc) "DIA-t" dia)
       (setq Qcourant ta)

      )

      ;;  cas d'une bouche                                    
      ;;                                                      


      ((= nombloc "bouche")
       (setq Qc	      (read (Vb-Val-att (handent hbloc) "Q"))
	     Qcourant (+ Qcourant Qc)
       )
       (Vb-Mod-att (handent hbloc) "T" (rtos Qcourant 2 0))
       (setq dia (calc-dia Qcourant v)
       )
       (Vb-Mod-att (handent hbloc) "DIA" dia)
      )
      ;;  cas d'un point non affect                          
      ;;                                                      


;;;      ((= nombloc "vide")
;;;
;;;       (setq pt1 (cadr (nth (+ 1 i) branche))
;;;
;;;       )
;;;      )

      ;; sortie sans condition  la fin du case                
      (t nil)
    )					;fc

    ;; cration de la liste des point avec paisseur
    (setq ldia (cons (list dia pt1) ldia))
    (setq i (+ 1 i))
  )					; fw
  ldia
  ;; valeur de retour de traite branche
)					;fd


;;                                                                                                                      
;;                                              fin de traitement branche                                                               
;;                                                                                                                      


;; Vb-Val-att fonction Vlisp pour lire la valeur d'un attribut      
					; ent correspond au handel du bloc (codedxf 5)  utiliser comme a  
;;   (setq toto (read (Vb-Val-att (handent handle) "REF")))         

(defun Vb-Val-att (ent nomatt / att val)

  (foreach att
	       (vlax-invoke
		 (vlax-ename->vla-object ent)
		 'getattributes
	       ) ;_ Fin de vlax-invoke
    (and (eq (vla-get-tagstring att) nomatt)
					;comme ils disent les fou du code "tournure lgante !"
	 (setq val (vla-get-textstring att))
					; le ET est quivalent  un si dans ce cas l 
    )					;car on afffecte Val que si att= nom-att  bravo Patrick_35
  ) ;_ Fin de foreach
  val
  ;; retour de fonction
) ;_ Fin de defun
;;                                                                      fin Vb-Val-att




;;  Vb-Mod-att fonction Vlisp pour modifier la valeur d'un attribut  ;;  utiliser comme a  
;;   (Vb-Mod-att (handent handle) "NIV" new-val)     (rtos 100)                              
;;  new-val est une string                                                                   

(defun Vb-Mod-att (ent nom-att nval / att inc vblst-att)
  (setq	inc 0
	vblst-att
	 (vlax-invoke
	   (vlax-ename->vla-object ent)
	   'getattributes
	 ) ;_ Fin de vlax-invoke
  ) ;_ Fin de setq

  (while (< inc (length vblst-att))
    (and (eq (vla-get-tagstring (nth inc vblst-att)) nom-att)
	 (vla-put-textstring (nth inc vblst-att) nval)
    )					;and
    (setq inc (+ 1 inc))
  ) ;_ Fin de while
)					;
					; fin Vb-Mod-att 



;;;;                    calcul diamtre

(defun calc-dia	(Q v / d dt)

  (setq d (sqrt (/ (* 4 Q) (* pi v 3600))))

  (cond
    ((< d 0.1)
     (setq dt "0.1")
    )

    ((< d 0.125)
     (setq dt "0.125")
    )

    ((< d 0.16)
     (setq dt "0.16")
    )

    ((< d 0.2)
     (setq dt "0.2")
    )

    ((< d 0.25)
     (setq dt "0.25")
    )

    ((< d 0.315)
     (setq dt 0.315)
    )

    ((< d 0.355)
     (setq dt "0.355")
    )

    ((< d 0.4)
     (setq dt "0.4")
    )

    ((< d 0.45)
     (setq dt "0.45")
    )

    ((< d 0.5)
     (setq dt "0.5")
    )

    ((< d 0.56)
     (setq dt 0.56)
    )

    ((< d 0.63)
     (setq dt "0.63")
    )

    ((< d 0.71)
     (setq dt "0.71")
    )

    ((< d 0.8)
     (setq dt "0.8")
    )

    ((< d 0.9)
     (setq dt "0.9")
    )

    ((< d 1.0)
     (setq dt "1.0")
    )

    (t nil)
    ;; sortie sans condition  la fin du case
  )					;fc

  dt

  ;;nbr de dcimales





)
;;;                    Fin diamtre                                                                                  




;;;;                    Fdxf avec effective name  VBA                                                                                   
(defun Fdxf (entite / lstdxf)		; l'argument et la variable
  (setq lstdxf (entget entite))		; liste dxf normale
;;; definition du nom vba de l'entite
  (setq Vba-ent (vlax-ename->vla-object entite))
;;; rcupration du effectivename et ajout  la lstdxf
  (setq bdn (vla-get-effectivename Vba-ent))
  (setq lstdxf (cons (cons "EffNameBlDyn" bdn) lstdxf))

  lstdxf				; le rappel de la variable sans rien sert
					;de valeur de retour de la fonction
)


;;; consolidation de la liste des diamtres                                         
(defun consolidation (lst / nlst i tour dia ndia lg nlg nel test)
  (setq tour 1)
  (setq	nlst (list (car lst))
	lst  (cdr lst)
  )

  (foreach el lst
    (setq dia  (car el)
	  lg   (cdr el)
	  test 0
    )

    (foreach nel nlst
      (setq ndia (car nel)
	    nlg	 (cdr nel)
      )

      (if (= ndia dia)
	(progn
	  (setq	nlg  (+ nlg lg)
		test 1
	  )
	  (setq nlst (subst (cons ndia nlg) nel nlst))
	)
      )					; c1

    )
    ;; f foreach nel

    (setq tour (+ 1 tour))
    (if	(= 0 test)
      (setq nlst (append (list el) nlst))
    )
  )					;f foreach el

  nlst
)





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; trace une poly et prpare la liste des dia + longueur dans *ldia* (variableglobale)
;; lst de la forme (("0.1"  (38.7212 -18.1476)) ("0.16" (1.9...

(defun trace-poly (lst / ploy lwpolyPts dia pt1 pt2 seg i test)
  (setq	test 0
	i 0
  )
  (while (< i (length lst))

    (setq pt1 (cadr (nth i lst))
	  dia (atof (car (nth i lst)))
    )
    (if	(< (+ 1 i) (length lst))
      (setq pt2	   (cadr (nth (+ 1 i) lst))
	    lg	   (distance pt1 pt2)
	    *ldia* (cons (cons dia lg) *ldia*)
      )
    )
    ;; liste des points + ep dbut et fin
    (setq lwpolyPts (append (list (list 10 (car pt1) (cadr pt1))
				  (cons 40 dia)
				  (cons 41 dia)
			    )
			    lwpolyPts
		    )
    )
    (setq i (+ 1 i)
    )
  )
;;; ffe


  ;; ; cration de la liste pour le entmake, le code 90 contient le nombre de sommets
  (setq	test 0
	poly (append
	       (list '(0 . "LWPOLYLINE")
		     '(100 . "AcDbEntity")
		     '(100 . "AcDbPolyline")
		     (cons 90 (length lst))
		     (cons 8 "--CVC-tmp")
	       )
	       lwpolyPts
	     )
  )
					;(print poly)
  (entmake poly)
)



;;                                                                                                              ;
;; la commande RTT permet de faire un raccord sur une poly en fonction de son paisseur                         ;
;; (coude R = 1 D) pour un autre rayon modifiez en dur dans le code la valuer de K )                            ;
;;                                                                                                              ;
;;                                                                                                              ;
;;                                                                                                              ;
;;                                                                                                              ;

(defun c:RTT (/ ent larg rad pl pt pa om)
  ;;   ini de VB
  (vl-load-com)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)		; Activer le dbut de l'undo

  (setq om (getvar "osmode"))
  (setvar "osmode" 512)

					;  (and
  (if
    (and
      (setq ent (entsel "\nSlectionnez un segment de polyligne: "))
      (setq pt (cadr ent))		; point cliqu
      (setq pl (car ent))		; entit slectionne
      (= (getpropertyvalue pl "LocalizedName") "Polyligne") ; contrle du type d'entit
      (setq pt (vlax-curve-getClosestPointTo pl (trans pt 1 0)))
					; point sur la polyligne le plus proche du point cliqu
      (setq pa (fix (vlax-curve-getParamAtPoint pl pt))) ; index du segment slectionn
    )
     (setq larg (getpropertyvalue pl "Vertices" pa "StartWidth")) ; largeur de dpart du segment
  )

  (setq rad (* 1 larg))
;;;;         Changer la valuer pour les coude R=2d ici

  (setvar "FILLETRAD" rad)
  (command "_fillet" "_radius" rad "_fillet" pt)
  (setvar "osmode" 6253)

)


;;                                                                                                              ;
;; la commande DTB permet poser des bouches automatiquement ser les points des position des diffuseurs          ;
;;   renseigne automatiquement l'attribut Q en ft du DEBIT du diffuseur                                         ;
;;                                                                                                              ;
;;                                                                                                              ;

(defun c:dtb (/ ent larg rad pl pt pa om)
  ;;   ini de VB
  (vl-load-com)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)		; Activer le dbut de l'undo

  (setq om (getvar "osmode"))
  (setvar "osmode" 512)

  (setq ent (entsel "\nSlectionnez un diffueur: "))
  ;; (setq pt (cadr ent))			; point cliqu
  (setq diff (fdxf (car ent)))
  (if (/= "diffuseur" (cdr (car diff)))
    ;; l'efective name du bloc voir fdxf
    (progn
      (print " le bloc n'est pas un diffuseur")
      (quit)
    )
  )

  (setq q (Vb-Val-att (car ent) "DEBIT"))

  (setq Pt (trans (cdr (assoc 10 (Att-lst (car ent) "pos"))) 0 1)) ; entit slectionne



  (command "_insert"
	   ;; on lance la commande INSERER
	   "BOUCHE"
	   ;; du bloc l
	   pt
	   ;; on attend que l'utilisateur donne le point d'insertion
	   0.3
	   ;; echelle x fixe  1
	   0.3
	   ;; echelle y fixe  1
	   0
	   ;; angle de rotation fixe  0
)

  (Vb-Mod-att (entlast) "Q" q)


  (setvar "osmode" 6253)
					;(command "_.undo" "_end")

)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;Att-lst  retourne la liste enget de l'attributs "nomatt" du bloc "entb" dans l'lment  ou nil si non trouv
;;;;;;; NOTA                                    
;;;;;;; 2  nom de l'attribut                    
;;;;;;; 10 coordonne du point de l'atrib       
;;;;;;; 1  valeur attrib                        
(defun Att-lst (entb nomatt / lst-att dxf-1)
  (if (= (cdr (assoc 0 (entget entb))) "INSERT")
    (progn
      (while (= lst-att nil)
	(setq entb (entnext entb))
	(setq dxf-1 (entget entb))
	(if (and (= (cdr (assoc 0 dxf-1)) "ATTRIB")
		 (= (cdr (assoc 2 dxf-1)) nomatt)
	    )
	  (setq lst-att dxf-1)
	)
      )
      lst-att				;valeur de retour
    )
    (progn
      (princ "la slection doit etre un bloc")
      (exit)
    )
  )
)

;;;;                Fdxf avec effective name  VBA                                 


(defun Fdxf (entite / lstdxf)		; l'argument et la variable
  (setq lstdxf (entget entite))		; liste dxf normale
;;; definition du nom vba de l'entite
  (setq Vba-ent (vlax-ename->vla-object entite))
;;; rcupration du effectivename et ajout  la lstdxf
  (setq bdn (vla-get-effectivename Vba-ent))
  (setq lstdxf (cons (cons "EffNameBlDyn" bdn) lstdxf))

  lstdxf				; le rappel de la variable sans rien sert
					;de valeur de retour de la fonction
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
































